# `.props() => Object`

Returns the props hash for the current node of the wrapper.

NOTE: can only be called on a wrapper of a single node.


#### Example


```jsx
const wrapper = shallow(<MyComponent foo={10} />);
expect(wrapper.props().foo).to.equal(10);
```


#### Related Methods

- [`.prop(key) => Any`](prop.md)
- [`.state([key]) => Any`](state.md)
- [`.context([key]) => Any`](context.md)
